import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import jpos.*;

public class ESCSequenceSample{
	public static void main(String args[]){		
		ESCSequenceFrame pnf = new ESCSequenceFrame();
		pnf.setVisible(true);
	}
}

class ESCSequenceFrame extends Frame implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Button escsequenceButton = null;
	Button closeButton = null;
	POSPrinter ptr = null;
	
	ESCSequenceFrame(){
		int width = 280;
		int height = 70;
		
		FlowLayout fl = new FlowLayout(FlowLayout.CENTER);
		this.setLayout(fl);
		escsequenceButton = new Button("ESCSequence");
		escsequenceButton.addActionListener(this);
		closeButton = new Button("Close");
		closeButton.addActionListener(this);
		this.add(escsequenceButton);
		this.add(closeButton);
		this.setTitle("ESCSequence Sample");
		Dimension dimen = Toolkit.getDefaultToolkit().getScreenSize();		
		this.setSize(width, height);
		this.setLocation(dimen.width/2-width/2, dimen.height/2 - height/2);		
		
		ptr = new POSPrinter();
		try {
			ptr.open("defaultPrinter");
			ptr.claim(0);
			ptr.setDeviceEnabled(true);
		} catch (JposException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == escsequenceButton){
			
			try {
				byte ESCSquence[] = new byte[]{0x1B, 0x7C};
				
				String str;

				//	Normal				
				str = "Normal\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Alings following text at the center				
				str = new String(ESCSquence) + "cA" + "Center\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Alings following text at the right
				str = new String(ESCSquence) + "rA" + "Right\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Prints in bold or double-strike
				str = new String(ESCSquence) + "bC" + "Bold\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);				
				
				//	Double wide 
				str = new String(ESCSquence) + "2C" + "Double-wide\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Double high 
				str = new String(ESCSquence) + "3C" + "Double-high\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Double high and wide 
				str = new String(ESCSquence) + "4C" + "Double-high/wide\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Double high and wide 
				str = new String(ESCSquence) + "3hC" + "3 times wide\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Double high and wide 
				str = new String(ESCSquence) + "3vC" + "3 times high\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);
				
				//	Normal
				str = new String(ESCSquence) + "N" + "Normal\r\n";
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, str);				
				
				ptr.markFeed(POSPrinterConst.PTR_MF_TO_TAKEUP); //In case of not page mode or transaction mode, 
																//you must call the mark feed function for printing.
			} catch (JposException jposEvent) {
				jposEvent.printStackTrace();
			}
		}
		else if(e.getSource() == closeButton)
			try {
				ptr.setDeviceEnabled(false);
				ptr.release();
				ptr.close();
				System.exit(0);
			} catch (JposException e1) {
				e1.printStackTrace();
				System.exit(0);
			}
	}
}
