import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import jpos.*;

public class PrintNormalSample{
	public static void main(String args[]){		
		PrintNormalFrame pnf;
		pnf = new PrintNormalFrame();
		pnf.setVisible(true);
	}
}

class PrintNormalFrame extends Frame implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Button printButton = null;
	Button closeButton = null;
	POSPrinter ptr = null;
	
	PrintNormalFrame(){
		int width = 250;
		int height = 70;
		
		FlowLayout fl = new FlowLayout(FlowLayout.CENTER);
		this.setLayout(fl);
		printButton = new Button("PrintNormal");
		printButton.addActionListener(this);
		closeButton = new Button("Close");
		closeButton.addActionListener(this);
		this.add(printButton);
		this.add(closeButton);
		this.setTitle("PrintNormal Sample");
		Dimension dimen = Toolkit.getDefaultToolkit().getScreenSize();		
		this.setSize(width, height);
		this.setLocation(dimen.width/2-width/2, dimen.height/2 - height/2);		

		ptr = new POSPrinter();
		try {
			ptr.open("defaultPrinter");
			ptr.claim(0);
			ptr.setDeviceEnabled(true);
		} catch (JposException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == printButton){
			try {
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "---------------------------\r\n");
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "JavaPOS Label Printer\n");
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Sample Program\n");
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "---------------------------\r\n");
				ptr.markFeed(POSPrinterConst.PTR_MF_TO_TAKEUP); //In case of not page mode or transaction mode, 
																//you must call the mark feed function for printing.
			} catch (JposException jposEvent) {
				jposEvent.printStackTrace();
			}
		}
		else if(e.getSource() == closeButton)
			try {
				ptr.setDeviceEnabled(false);
				ptr.release();
				ptr.close();
				System.exit(0);
			} catch (JposException e1) {
				e1.printStackTrace();
				System.exit(0);				
			}			
	}
}
