import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import jpos.*;

public class PrintBarcodeSample{
	public static void main(String args[]){		
		PrintBarcodeFrame pbf = new PrintBarcodeFrame();
		pbf.setVisible(true);
	}
}

class PrintBarcodeFrame extends Frame implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Button printbarcodeButton = null;
	Button closeButton = null;
	POSPrinter ptr = null;
	
	PrintBarcodeFrame(){
		int width = 300;
		int height = 70;
		
		FlowLayout fl = new FlowLayout(FlowLayout.CENTER);
		this.setLayout(fl);
		printbarcodeButton = new Button("PrintBarcode");
		printbarcodeButton.addActionListener(this);
		closeButton = new Button("Close");
		closeButton.addActionListener(this);
		this.add(printbarcodeButton);
		this.add(closeButton);
		this.setTitle("PrintBarcode Sample");
		Dimension dimen = Toolkit.getDefaultToolkit().getScreenSize();		
		this.setSize(width, height);
		this.setLocation(dimen.width/2-width/2, dimen.height/2 - height/2);		
		
		ptr = new POSPrinter();
		try {
			ptr.open("defaultPrinter");
			ptr.claim(0);
			ptr.setDeviceEnabled(true);
		} catch (JposException e) {
			e.printStackTrace();
			System.exit(0);
		}		
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == printbarcodeButton){
			try {
				byte ESCSquence[] = new byte[]{0x1B, 0x7C};				
				//	PrintBarcode
				ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "123456789012", POSPrinterConst.PTR_BCS_UPCA, 255, 512, POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_NONE);
				//	Feed 7 lines
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, new String(ESCSquence) + "7lF");				
			} catch (JposException jposEvent) {
				jposEvent.printStackTrace();
			}
		}
		else if(e.getSource() == closeButton)
			try {
				ptr.setDeviceEnabled(false);
				ptr.release();
				ptr.close();
				System.exit(0);
			} catch (JposException e1) {
				e1.printStackTrace();
				System.exit(0);
			}
	}
}
