import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import jpos.*;

import org.apache.commons.lang.SystemUtils;

public class PrintBitmapSample{
	public static void main(String args[]){		
		PrintBitmapFrame pbf = new PrintBitmapFrame();
		pbf.setVisible(true);
	}
}

class PrintBitmapFrame extends Frame implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Button printbitmapButton = null;
	Button closeButton = null;
	POSPrinter ptr = null;
	
	PrintBitmapFrame(){
		int width = 250;
		int height = 70;
		
		FlowLayout fl = new FlowLayout(FlowLayout.CENTER);
		this.setLayout(fl);
		printbitmapButton = new Button("PrintBitmap");
		printbitmapButton.addActionListener(this);
		closeButton = new Button("Close");
		closeButton.addActionListener(this);
		this.add(printbitmapButton);
		this.add(closeButton);
		this.setTitle("PrintBitmap Sample");
		Dimension dimen = Toolkit.getDefaultToolkit().getScreenSize();		
		this.setSize(width, height);
		this.setLocation(dimen.width/2-width/2, dimen.height/2 - height/2);		
		
		ptr = new POSPrinter();
		try {
			ptr.open("defaultPrinter");
			ptr.claim(0);
			ptr.setDeviceEnabled(true);
		} catch (JposException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == printbitmapButton){			
			try {
				byte ESCSquence[] = new byte[]{0x1B, 0x7C};

				//	Printbitmap
				if(SystemUtils.IS_OS_WINDOWS)
					ptr.printBitmap(POSPrinterConst.PTR_S_RECEIPT, ".\\sampleimage.bmp", 300, POSPrinterConst.PTR_BM_CENTER);
				else
					ptr.printBitmap(POSPrinterConst.PTR_S_RECEIPT, "./sampleimage.bmp", 300, POSPrinterConst.PTR_BM_CENTER);
				//	Feed 7 lines
				ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, new String(ESCSquence) + "7lF");				
			} catch (JposException jposEvent) {
				jposEvent.printStackTrace();
			}
		}
		else if(e.getSource() == closeButton)
			try {
				ptr.setDeviceEnabled(false);
				ptr.release();
				ptr.close();
				System.exit(0);
			} catch (JposException e1) {
				e1.printStackTrace();
			}
	}
}
